;       cpu  Z80UNDOC

;       RELAXED ON

         
;RUSSIAN KEMPSTON MOUSE DRIVER

	org #8000         

	output kmdrvshort.bin

XMAX     equ  255
XMIN     equ  0
         
YMAX     equ  191
YMIN     equ  0
         
;XECUTE MOUSE
;TAKE COORDINATES FROM CURPOS=
;=COORD
         
MOUSE    
         ld   hl,(COORD)
;L=X-axis
;H=Y-axis
         ld   bc,$FBDF
         ld   de,(OLDCO)
         in   a,(c)
         ld   (OLDCO),a
         sub  e
         jr   z,NM_X
         jp   p,MX_PL
         add  a,l
         jr   c,ZER_X
         xor  a
ZER_X    ld   l,a
         jr   NM_X
MX_PL    add  a,l
         jr   c,BEX_Z
         cp   XMAX
         jr   c,BEX_B
BEX_Z    ld   a,XMAX
BEX_B    ld   l,a
NM_X     ld   b,$FF
         in   a,(c)
         ld   (OLDCO+1),a
         sub  d
         jr   z,NM_Y
         neg  
         jp   p,MY_PL
         add  a,h
         jr   c,ZER_Y
         xor  a
ZER_Y    ld   h,a
         jr   NM_Y
MY_PL    add  a,h
         jr   c,BEY_Z
         cp   YMAX
         jr   c,BEY_B
BEY_Z    ld   a,YMAX
BEY_B    ld   h,a
NM_Y     ld   a,h
         cp   $FF
         jr   c,BIGY
         ld   h,$FF
BIGY     cp   YMIN
         jr   nc,SMALY
         ld   h,YMIN
SMALY    ld   a,l
         cp   $FF
         jr   c,DIRY
         ld   l,$FF
DIRY     cp   XMIN
         jr   nc,DIMENS
         ld   l,XMIN
DIMENS   ld   (COORD),hl
         ld   bc,$FADF
         in   a,(c)
         cpl  
         and  7
         ld   (CONTRB),a
         ret  
;------------------------------
;INPUT: L=new X-axis
;       H=new Y-axis
         
KOREKCE  ld   a,$FB
         in   a,($DF)
         ld   (OLDCO),a
         ld   a,$FF
         in   a,($DF)
         ld   (OLDCO+1),a
         ld   (COORD),hl
         ret  
;------------------------------
;new cursor position
COORD    defb 0,0
         
;buttons status
CONTRB   defb 0
         
;working (previous position)
OLDCO    defb 0,0
;------------------------------
LENGTH   equ  $-MOUSE